## mingw-w64-mopac-23.2.2-1.src.tar.zst

=== src/MOZYME/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list
    mbonds fillij check hbonds buildf add_more_interactions
    isitsc setupk chrge_for_MOZYME reorth set_up_MOZYME_arrays
    eimp vecprt_for_MOZYME outer2 compct cnvgz diagg
    kab_for_MOZYME bonds_for_MOZYME prtlmo density_for_MOZYME
    addhb dipole_for_MOZYME local_for_MOZYME fock2z local2
    helecz scfcri MOZYME_C epseta iter_for_MOZYME pinout
    denrot_for_MOZYME fock1_for_MOZYME jab_for_MOZYME hybrid
    hcore_for_MOZYME tidy makvec selmos diagg2 mlmo
    convert_storage outer1 diagg1 adjvec MOZYME_eigs
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/PARAM/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list
    getpar partab extract_parameter pardip psort
    rapid0 rapid1 rapid3 resetp getmol datinp
    direct parkey rapid2 parfg Param_global_C
    optgeo pparsav finish depfn savgeo pargeo
    empire parips filusp chkpar
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/SCF/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list 
    cnvg resolv fock2 iter_C swap local fock1
    capcor iter pulay
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/forces/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list 
    deriv deri1 freqcy jcarin dcart deri23 delsta
    dfield dfock2 xyzcry forsav deri22 anavib
    deri0 intfc dhcore dhc deri2 force dijkl1
    dijkl2 dernvo deri21 fmat frame deritr
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/integrals/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list 
    set h1elec diat kab ccrep hcore jab mndod_C
    rotate bfn mndod helect coe sp_two_electron
    solrot
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/matrix/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list 
    schmib linpack densit density_for_GPU mtxmc
    mxmt mat33 interp mxv diag_for_GPU
    eigenvectors_LAPACK mult_symm_AB mtxm supdot
    molval schmit mxm diag rsp mult dot minv
    mamult esp_utilities osinv ddiag
    )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== src/optimization/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#===============================================
# Create a list of source files (src_list) with the .F90 extension
set(src_list 
    nllsq flepo linmin locmin parsav powsq dfpsav
    exchng lbfgs ef_C ef
   )
#-----------------------------------------------
# Add a list of source files to the target
foreach(idx IN LISTS src_list)
        target_sources(mopac-core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/${idx}.F90)
endforeach()
#===============================================

=== tests/keywords/CMakeLists.txt ===
# Molecular Orbital PACkage (MOPAC)
# Copyright 2021 Virginia Polytechnic Institute and State University
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Basic tests for parsing/using each MOPAC keyword, including obsolete keywords & old syntax for backward compatibility

add_mopac_test(key-ampersand "ampersand.mop")
add_mopac_test(key-plus "plus.mop")
add_mopac_test(key-plusplus "plusplus.mop")
add_mopac_test(key-0SCF "0SCF.mop")
add_mopac_test(key-1ELECTRON "1ELECTRON.mop")
add_mopac_test(key-1SCF "1SCF.mop")
add_mopac_test(key-A0 "A0.mop")
add_mopac_test(key-AIGIN "AIGIN.mop")
add_mopac_test(key-AIGOUT "AIGOUT.mop")
add_mopac_test(key-ALLBONDS "ALLBONDS.mop")
add_mopac_test(key-ALLVEC "ALLVEC.mop")
add_mopac_test(key-AM1 "AM1.mop")
add_mopac_test(key-ANGSTROMS "ANGSTROMS.mop")
add_mopac_test(key-AUTOSYM "AUTOSYM.mop")
#add_mopac_test(key-BANANA "BANANA.mop")
add_mopac_test(key-BIRADICAL "BIRADICAL.mop")
#add_mopac_test(key-BONDS "BONDS.mop")
add_mopac_test(key-CdotAdotSdot "CdotAdotSdot.mop")
add_mopac_test(key-CdotIdot "CdotIdot.mop")
add_mopac_test(key-CdotIdotDdot "CdotIdotDdot.mop")
#add_mopac_test(key-CARTAB "CARTAB.mop")
add_mopac_test(key-CHARGE "CHARGE.mop")
#add_mopac_test(key-CHARGES "CHARGES.mop")
#add_mopac_test(key-CHARST "CHARST.mop")
add_mopac_test(key-CIS "CIS.mop")
add_mopac_test(key-CISD "CISD.mop")
add_mopac_test(key-CISDT "CISDT.mop")
#add_mopac_test(key-COMPFG "COMPFG.mop")
#add_mopac_test(key-DCART "DCART.mop")
#add_mopac_test(key-DEBUG "DEBUG.mop")
#add_mopac_test(key-DEBUGPULAY "DEBUGPULAY.mop")
#add_mopac_test(key-DERI1 "DERI1.mop")
#add_mopac_test(key-DERI2 "DERI2.mop")
#add_mopac_test(key-DERITR "DERITR.mop")
#add_mopac_test(key-DERIV "DERIV.mop")
#add_mopac_test(key-DERNVO "DERNVO.mop")
#add_mopac_test(key-DFORCE "DFORCE.mop")
add_mopac_test(key-DISP "DISP.mop")
add_mopac_test(key-DOUBLET "DOUBLET.mop")
#add_mopac_test(key-ECHO "ECHO.mop")
#add_mopac_test(key-EIGEN "EIGEN.mop")
#add_mopac_test(key-EIGS "EIGS.mop")
add_mopac_test(key-EXCITED "EXCITED.mop")
add_mopac_test(key-EXTERNAL "EXTERNAL.mop;EXTERNAL.dat")
add_mopac_test(key-EXTERNAL-2 "EXTERNAL_2.mop")
#add_mopac_test(key-FLEPO "FLEPO.mop")
#add_mopac_test(key-FMAT "FMAT.mop")
#add_mopac_test(key-FOCK "FOCK.mop")
#add_mopac_test(key-FREQCY "FREQCY.mop")
#add_mopac_test(key-GRADIENTS "GRADIENTS.mop")
#add_mopac_test(key-HCORE "HCORE.mop")
#add_mopac_test(key-HESSIAN "HESSIAN.mop")
add_mopac_test(key-INDO "INDO.mop")
#add_mopac_test(key-ITER "ITER.mop")
#add_mopac_test(key-LARGE "LARGE.mop")
#add_mopac_test(key-LINMIN "LINMIN.mop")
#add_mopac_test(key-LOCAL "LOCAL.mop")
add_mopac_test(key-MAXCI "MAXCI.mop")
add_mopac_test(key-MECI "MECI.mop")
#add_mopac_test(key-MINI "MINI.mop")
add_mopac_test(key-MNDO "MNDO.mop")
add_mopac_test(key-MNDOD "MNDOD.mop")
#add_mopac_test(key-MOLDAT "MOLDAT.mop")
#add_mopac_test(key-MOLSYM "MOLSYM.mop")
add_mopac_test(key-MRCI "MRCI.mop")
add_mopac_test(key-MS "MS.mop")
#add_mopac_test(key-MULLIK "MULLIK.mop")
add_mopac_test(key-NOANCI "NOANCI.mop")
add_mopac_test(key-NONET "NONET.mop")
add_mopac_test(key-NOSYM "NOSYM.mop")
#add_mopac_test(key-NOXYZ "NOXYZ.mop")
add_mopac_test(key-OCTET "OCTET.mop")
add_mopac_test(key-OPEN "OPEN.mop")
add_mopac_test(key-PECI "PECI.mop")
#add_mopac_test(key-PKA "PKA.mop")
add_mopac_test(key-PM3 "PM3.mop")
add_mopac_test(key-PM6 "PM6.mop")
add_mopac_test(key-PM6-D3 "PM6-D3.mop")
add_mopac_test(key-PM6-D3H4 "PM6-D3H4.mop")
add_mopac_test(key-PM6-D3H4X "PM6-D3H4X.mop")
add_mopac_test(key-PM6-DHplus "PM6-DHplus.mop")
add_mopac_test(key-PM6-DH2 "PM6-DH2.mop")
add_mopac_test(key-PM6-DH2X "PM6-DH2X.mop")
add_mopac_test(key-PM7 "PM7.mop")
add_mopac_test(key-PM7-TS "PM7-TS.mop")
#add_mopac_test(key-POWSQ "POWSQ.mop")
#add_mopac_test(key-PRNT "PRNT.mop")
#add_mopac_test(key-PRTCHAR "PRTCHAR.mop")
#add_mopac_test(key-PRTINT "PRTINT.mop")
#add_mopac_test(key-PRTMEP "PRTMEP.mop")
#add_mopac_test(key-PRTXYZ "PRTXYZ.mop")
add_mopac_test(key-QUARTET "QUARTET.mop")
add_mopac_test(key-QUINTET "QUINTET.mop")
#add_mopac_test(key-RABBIT "RABBIT.mop")
#add_mopac_test(key-RAMA "RAMA.mop")
#add_mopac_test(key-RE-LOCAL "RE-LOCAL.mop")
add_mopac_test(key-RHF "RHF.mop")
add_mopac_test(key-RM1 "RM1.mop")
add_mopac_test(key-ROOT "ROOT.mop")
add_mopac_test(key-SEPTET "SEPTET.mop")
add_mopac_test(key-SEXTET "SEXTET.mop")
add_mopac_test(key-SINGLET "SINGLET.mop")
add_mopac_test(key-SNAP "SNAP.mop")
#add_mopac_test(key-SPIN "SPIN.mop")
#add_mopac_test(key-SUPER "SUPER.mop")
add_mopac_test(key-SYMMETRY "SYMMETRY.mop")
#add_mopac_test(key-SYMOIR "SYMOIR.mop")
#add_mopac_test(key-SYMTRZ "SYMTRZ.mop")
add_mopac_test(key-TDIP "TDIP.mop")
#add_mopac_test(key-TIMES "TIMES.mop")
add_mopac_test(key-TRIPLET "TRIPLET.mop")
add_mopac_test(key-UHF "UHF.mop")
#add_mopac_test(key-VECTORS "VECTORS.mop")
add_mopac_test(key-WRTCI "WRTCI.mop")
add_mopac_test(key-WRTCONF "WRTCONF.mop")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=mopac
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=23.2.2
pkgrel=1
pkgdesc="Molecular Orbital PACkage. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='http://openmopac.net'
msys2_repository_url='https://github.com/openmopac/mopac'
msys2_references=(
  'anitya: 269958'
  'aur: mopac'
)
license=('spdx:Apache-2.0')
depends=($([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python"
              "${MINGW_PACKAGE_PREFIX}-python-numpy")
source=("https://github.com/openmopac/mopac/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-Fix-installing-library.patch")
sha256sums=('d64525fa4ae709b214ecbd5981b7e8a2928e2f1a91d85a253e8dbd04616e14cd'
            '311b4224e04a109ff4f073254a0a716c1989e035bbeeb7033f9d61c0208419e5')

prepare() {
  cd "${_realname}-${pkgver}"

  patch -Np1 -i "${srcdir}"/0001-Fix-installing-library.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    extra_config+=("-DTHREADS_KEYWORD=OFF")
  else
    extra_config+=("-DTHREADS_KEYWORD=ON")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -G"MSYS Makefiles" \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DF2003_INTRINSICS=ON \
      -DENABLE_MKL=OFF \
      -DGIT_HASH=OFF \
      -DTESTS=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake \
    -DTESTS=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -S "${_realname}-${pkgver}" \
    -B "build-${MSYSTEM}"
  cmake  --build "build-${MSYSTEM}"

  ctest --test-dir build-${MSYSTEM} --output-on-failure
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}" --component redist

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
  rm "${pkgdir}"${MINGW_PREFIX}/include/LICENSE
  rm "${pkgdir}"${MINGW_PREFIX}/LICENSE

  mkdir -p "${pkgdir}"${MINGW_PREFIX}/share/doc/${_realname}
  mv "${pkgdir}"${MINGW_PREFIX}/CITATION.cff "${pkgdir}"${MINGW_PREFIX}/share/doc/${_realname}/
}
